<?php
	
	
	namespace Infocob\CrmForms\Admin;
	
	class Tools {
		
		public static function extractShortCode($string) {
			$string = preg_replace("/(\[\/?group.*])/mi", "", $string);
			preg_match_all("/(\[(?!\/|submit|recaptcha).*\])/mi", $string, $shortcode);
			
			return $shortcode[0];
		}
		
		public static function getShortCodeName($shortcode) {
			preg_match("/^(\[[^\ ]* ([^\ ]*))/mi", $shortcode, $newShortcode);
			$result = !empty($newShortcode[2]) ? rtrim($newShortcode[2], "]") : $shortcode;
			return $result;
		}
		
		public static function explodeShortName($string){
			$stringExplode = explode('"', $string);
			if(strstr($stringExplode[0], 'select')){
				return $stringExplode[0] . "]";
			} else {
				return $string;
			}
		}
		
		public static function sanitize_fields($data, $stripslashes = false) {
			if(is_string($data)) {
				$data = $stripslashes ? stripslashes(sanitize_text_field($data)) : sanitize_text_field($data);
				
			} else if(is_int($data)) {
				$data = (int) $data;
				
			} else if(is_bool($data)) {
				$data = (bool) $data;
				
			} else if(is_array($data)) {
				foreach($data as $key => &$value) {
					if(is_array($value)) {
						$value = static::sanitize_fields($value);
					} else {
						if(is_string($value)) {
							$value = $stripslashes ? stripslashes(sanitize_text_field($value)) : sanitize_text_field($value);
						} else if(is_int($value)) {
							$value = (int) $value;
						} else if(is_bool($value)) {
							$value = (bool) $value;
						}
					}
				}
			}
			
			return $data;
		}
		
		public static function infocob_register_data_db_filterStripSlashes(&$value) {
			$value = stripslashes($value); // PROBLEM BACKSLASH
		}
		
		public static function validate_google_recaptcha_v3($token) {
			// Google Recaptcha V3
			$options                = get_option('infocob_crm_forms_settings');
			$google_recaptcha_v3_secret_key = $options['google_recaptcha_v3']['secret_key'] ?? false;
			
			if (!isset($token) && $google_recaptcha_v3_secret_key) {
				return false;
			}
			$siteverify = 'https://www.google.com/recaptcha/api/siteverify';
			
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $siteverify . '?secret=' . $google_recaptcha_v3_secret_key . '&response=' . $token);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			$response = curl_exec($ch);
			curl_close($ch);
			
			$response = json_decode($response, true);
			
			return $response['success'] ?? false;
		}
	}
